searchNodes=[{"doc":"Md is a markup parser allowing fully customized syntax definition and understanding the wide range of markdown out of the box. It is stream-aware, extendable, flexible, blazingly fast, with callbacks and more. Main Focus This library is not yet another markdown parser, rather it’s a highly configurable and extendable parser for any custom markdown-like markup. It has been created mostly to allow custom markdown syntax, like ^foo^ for superscript, or ⇓bar⇓ for subscript. It also supports custom parsers for anything that cannot be handled with generic parsers, inspired by markdown (something more complex than standard markdown provides.) The library provides callbacks for all the default syntax handlers, as well as for custom handlers, allowing the on-fly modification of what’s currently being processed. Md parses the incoming stream once and keeps the state, producing an AST of the input document. It has an ability to recover from errors collecting them. It currently does not support (and I frankly doubt it ever will) lists with embedded quotes, and other contrived syntax. If one needs to perfectly parse the common markdown, Md is probably not the correct choice. But if one wants to easily extend syntax almost without limits, Md might be good. Markup Handling There are several different syntax patterns recognizable by Md . Those are: custom — the custom parser implementing Md.Parser behavious would be called substitute — simple substitution, like &quot;&lt;&quot; →  &quot;&amp;lt;&quot; escape — characters to be treated as is, not as a part of syntax comment — characters to be treated as a comment, discarded in the output flush — somewhat breaking a paragraph flow, like triple-dash magnet — the markup for a single work following the patters, like #tag block — the whole block of input treated distinguished, like triple-backtick shift  — the same as block , but the opening marker should precede each line and &quot;\\n&quot; is treated as the closing marker pair — the opening marker followed by closing marker, and a subsequent pair of opening and closing, like ![name](#anchor) ; the second element might be an internal shortcut to the deferred disclosure disclosure — the disclosure of elements previously declared as pair with deferred parameter provided paragraph — a header, blockquote, or such, followed by a paragraph flow break list — a list, like - one\\n-two tag — allowed tags (e. g. &lt;sup&gt;2&lt;/sup&gt; ) brace — a most common markdown feature, like text decoration or such (e. g. **bold** ) Syntax description The syntax must be configured at compile time (because parse/2 handlers are generated in compile time.) It is a map, having settings key settings : %{ outer : :p , span : :span , empty_tags : ~w|img hr br|a } and key ⇒ list_of_tuples key-values, providing a text markup representation and its handling rules. Here is the excerpt from the default parser for brace s brace : %{ &quot;*&quot; =&gt; %{ tag : :b } , &quot;_&quot; =&gt; %{ tag : :i } , &quot;**&quot; =&gt; %{ tag : :strong , attributes : %{ class : &quot;nota-bene&quot; } } , &quot;__&quot; =&gt; %{ tag : :em } , &quot;~&quot; =&gt; %{ tag : :s } , &quot;~~&quot; =&gt; %{ tag : :del } , &quot;`&quot; =&gt; %{ tag : :code , mode : :raw , attributes : %{ class : &quot;code-inline&quot; } } } For more examples of what properties are allowed for each kind of handlers, see the sources (ATM.) Predefined parsers Md comes with a generic predefined parser Md.Parser.Default , which includes all the markup currently supported by Md . Custom parser definition would be usually based on Md.Parser.Syntax.Void syntax as shown below defmodule MyParser do use Md.Parser alias Md.Parser.Syntax.Void @default_syntax Map . put ( Void . syntax ( ) , :settings , Void . settings ( ) ) @syntax @default_syntax |&gt; Map . merge ( %{ comment : [ { &quot;&lt;!--&quot; , %{ closing : &quot;--&gt;&quot; } } ] , paragraph : [ { &quot;##&quot; , %{ tag : :h2 } } , { &quot;###&quot; , %{ tag : :h3 } } , { &quot;&gt;&quot; , %{ tag : :blockquote } } ] , list : [ { &quot;- &quot; , %{ tag : :li , outer : :ul } } , { &quot;+ &quot; , %{ tag : :li , outer : :ol } } ] brace : [ { &quot;*&quot; , %{ tag : :b } } , { &quot;_&quot; , %{ tag : :i } } , { &quot;~&quot; , %{ tag : :s } } , { &quot;`&quot; , %{ tag : :code , mode : :raw , attributes : %{ class : &quot;code-inline&quot; } } } ] } ) end @syntax module attribute must be declared, or DSL used as shown below (declarations), or an argument in a call to use Md.Parser . The separate declarations will be collected and merged. defmodule MyDSLParser do @my_syntax %{ brace : [ { &quot;***&quot; , %{ tag : &quot;u&quot; } } ] } use Md.Parser , syntax : @my_syntax import Md.Parser.DSL comment &quot;&lt;!--&quot; , %{ closing : &quot;--&gt;&quot; } ... end Instead of @syntax module attribute, one might use a parameter to use Md.Parser as use Md.Parser, syntax: map() a DSL like paragraph {&quot;#&quot;, %{tag: :h1}} .","ref":"Md.html","title":"Md","type":"module"},{"doc":"See Md.Parser.generate/1 .","ref":"Md.html#generate/1","title":"Md.generate/1","type":"function"},{"doc":"See Md.Parser.generate/2 .","ref":"Md.html#generate/2","title":"Md.generate/2","type":"function"},{"doc":"See Md.Parser.generate/3 .","ref":"Md.html#generate/3","title":"Md.generate/3","type":"function"},{"doc":"Interface to the library. Use parse/2 to parse the input to the state, use generate/{1,2} to produce an HTML out of the input. Examples iex&gt; Md . parse ( &quot; foo&quot; ) % Md.Parser.State { ast : [ { :p , nil , [ &quot;foo&quot; ] } ] , mode : [ :finished ] } iex&gt; Regex . replace ( ~r/ \\s +/ , Md . generate ( &quot;*bold*&quot; ) , &quot;&quot; ) &quot;&lt;p&gt;&lt;b&gt;bold&lt;/b&gt;&lt;/p&gt;&quot; iex&gt; Md . generate ( &quot;It’s all *bold* and _italic_!&quot; , Md.Parser.Default , format : :none ) &quot;&lt;p&gt;It’s all &lt;b&gt;bold&lt;/b&gt; and &lt;i&gt;italic&lt;/i&gt;!&lt;/p&gt;&quot;","ref":"Md.html#parse/2","title":"Md.parse/2","type":"function"},{"doc":"Several guards for the proper UTF8 handling of input. Examples iex&gt; import Md.Guards iex&gt; with &lt;&lt; x :: utf8 , _ :: binary &gt;&gt; &lt;- &quot; &quot; , do : is_ascii_space ( x ) true iex&gt; with &lt;&lt; x :: utf8 , _ :: binary &gt;&gt; &lt;- &quot; &quot; , do : is_non_ascii_space ( x ) false iex&gt; with &lt;&lt; x :: utf8 , _ :: binary &gt;&gt; &lt;- &quot; &quot; , do : is_utf8_space ( x ) true iex&gt; with &lt;&lt; x :: utf8 , _ :: binary &gt;&gt; &lt;- &quot;!&quot; , do : is_ascii_punct ( x ) true iex&gt; with &lt;&lt; x :: utf8 , _ :: binary &gt;&gt; &lt;- &quot;!&quot; , do : is_non_ascii_punct ( x ) false iex&gt; with &lt;&lt; x :: utf8 , _ :: binary &gt;&gt; &lt;- &quot;!&quot; , do : is_utf8_punct ( x ) true iex&gt; with &lt;&lt; x :: utf8 , _ :: binary &gt;&gt; &lt;- &quot;1&quot; , do : is_ascii_digit ( x ) true iex&gt; with &lt;&lt; x :: utf8 , _ :: binary &gt;&gt; &lt;- &quot;1&quot; , do : is_non_ascii_digit ( x ) false iex&gt; with &lt;&lt; x :: utf8 , _ :: binary &gt;&gt; &lt;- &quot;①&quot; , do : is_utf8_digit ( x ) true","ref":"Md.Guards.html","title":"Md.Guards","type":"module"},{"doc":"","ref":"Md.Guards.html#is_ascii_digit/1","title":"Md.Guards.is_ascii_digit/1","type":"macro"},{"doc":"","ref":"Md.Guards.html#is_ascii_punct/1","title":"Md.Guards.is_ascii_punct/1","type":"macro"},{"doc":"","ref":"Md.Guards.html#is_ascii_space/1","title":"Md.Guards.is_ascii_space/1","type":"macro"},{"doc":"","ref":"Md.Guards.html#is_non_ascii_digit/1","title":"Md.Guards.is_non_ascii_digit/1","type":"macro"},{"doc":"","ref":"Md.Guards.html#is_non_ascii_punct/1","title":"Md.Guards.is_non_ascii_punct/1","type":"macro"},{"doc":"","ref":"Md.Guards.html#is_non_ascii_space/1","title":"Md.Guards.is_non_ascii_space/1","type":"macro"},{"doc":"","ref":"Md.Guards.html#is_utf8_digit/1","title":"Md.Guards.is_utf8_digit/1","type":"macro"},{"doc":"","ref":"Md.Guards.html#is_utf8_punct/1","title":"Md.Guards.is_utf8_punct/1","type":"macro"},{"doc":"","ref":"Md.Guards.html#is_utf8_space/1","title":"Md.Guards.is_utf8_space/1","type":"macro"},{"doc":"The listener behaviour to attach to the parser to receive callbacks when the elements are encountered and processed.","ref":"Md.Listener.html","title":"Md.Listener","type":"behaviour"},{"doc":"","ref":"Md.Listener.html#c:element/2","title":"Md.Listener.element/2","type":"callback"},{"doc":"","ref":"Md.Listener.html#t:attributes/0","title":"Md.Listener.attributes/0","type":"type"},{"doc":"","ref":"Md.Listener.html#t:branch/0","title":"Md.Listener.branch/0","type":"type"},{"doc":"","ref":"Md.Listener.html#t:callback/0","title":"Md.Listener.callback/0","type":"type"},{"doc":"","ref":"Md.Listener.html#t:context/0","title":"Md.Listener.context/0","type":"type"},{"doc":"","ref":"Md.Listener.html#t:element/0","title":"Md.Listener.element/0","type":"type"},{"doc":"","ref":"Md.Listener.html#t:leaf/0","title":"Md.Listener.leaf/0","type":"type"},{"doc":"","ref":"Md.Listener.html#t:parse_mode/0","title":"Md.Listener.parse_mode/0","type":"type"},{"doc":"","ref":"Md.Listener.html#t:state/0","title":"Md.Listener.state/0","type":"type"},{"doc":"","ref":"Md.Listener.html#t:trace/0","title":"Md.Listener.trace/0","type":"type"},{"doc":"Interface to implement for the custopm parsers. Custom parsers might be used in syntax declaration when the generic functionality is not enough. Let’s consider one needs a specific handling of links with titles. The generic engine does not support it, so one would need to implement a custom parser and instruct Md.Parser to use it with: # config/prod.exs config :md , syntax : %{ custom : %{ { &quot;![&quot; , MyApp.Parsers.Img } , ... } } Once the original parser would meet the &quot;![&quot; binary, it’d call MyApp.Parsers.Img.parse/2 . The latter must proceed until the tag is closed and return the remainder and the updated state as a tuple.","ref":"Md.Parser.html","title":"Md.Parser","type":"behaviour"},{"doc":"The main function transforming the MD input to XML output. options are passed to XmlBuilder.generate/2 as is, save for the special two special options, parser: and walker: . parser: option which is a module implementing Parser behaviour, is telling what parser to use for parsing. walker: option which might be a function of arity 2, or a tuple {:pre | :post, fun} where fun is a function of arity 1 or 2. If passed, XmlBuilder.{pre,post}walk/{2,3} is being called before generation. If walker: was not passed, or a nil value was returned from the accumulator, this function returns the binary XML as is, otherwise it returns a tuple {XML, accumulator} where accumulator is what has been returned from underlying calls to XmlBuilder.traverse/4 .","ref":"Md.Parser.html#generate/2","title":"Md.Parser.generate/2","type":"function"},{"doc":"","ref":"Md.Parser.html#generate/3","title":"Md.Parser.generate/3","type":"function"},{"doc":"Takes a not parsed yet input and the state, returns the updated remainder and state.","ref":"Md.Parser.html#c:parse/2","title":"Md.Parser.parse/2","type":"callback"},{"doc":"The type to be used in all the intermediate states of parsing. The first element iof the tuple is the continuation (not parsed yet input,) and the latter is the current state.","ref":"Md.Parser.html#t:parsing_stage/0","title":"Md.Parser.parsing_stage/0","type":"type"},{"doc":"Default parser with all the features included. Supports a wide subset of markdown, including but not limited to: bold/italic/strikeout/etc text decorations comments code blocks tables twitter handlers etc Might be a good start for those who just needs a fast markdown processing.","ref":"Md.Parser.Default.html","title":"Md.Parser.Default","type":"module"},{"doc":"","ref":"Md.Parser.Default.html#listener/2","title":"Md.Parser.Default.listener/2","type":"function"},{"doc":"","ref":"Md.Parser.Default.html#syntax/0","title":"Md.Parser.Default.syntax/0","type":"function"},{"doc":"The internal state of the parser.","ref":"Md.Parser.State.html","title":"Md.Parser.State","type":"module"},{"doc":"","ref":"Md.Parser.State.html#t:t/0","title":"Md.Parser.State.t/0","type":"type"},{"doc":"The behaviour for the custom syntax suppliers","ref":"Md.Parser.Syntax.html","title":"Md.Parser.Syntax","type":"behaviour"},{"doc":"","ref":"Md.Parser.Syntax.html#merge/2","title":"Md.Parser.Syntax.merge/2","type":"function"},{"doc":"The implementation should return settings for this particular syntax definition","ref":"Md.Parser.Syntax.html#c:settings/0","title":"Md.Parser.Syntax.settings/0","type":"callback"},{"doc":"The implementation should return a syntax definition","ref":"Md.Parser.Syntax.html#c:syntax/0","title":"Md.Parser.Syntax.syntax/0","type":"callback"},{"doc":"List of different types of markup","ref":"Md.Parser.Syntax.html#types/0","title":"Md.Parser.Syntax.types/0","type":"function"},{"doc":"Syntax item definition","ref":"Md.Parser.Syntax.html#t:item/0","title":"Md.Parser.Syntax.item/0","type":"type"},{"doc":"Settings for the parser","ref":"Md.Parser.Syntax.html#t:settings/0","title":"Md.Parser.Syntax.settings/0","type":"type"},{"doc":"Syntax definition","ref":"Md.Parser.Syntax.html#t:t/0","title":"Md.Parser.Syntax.t/0","type":"type"},{"doc":"Void syntax to be extended by custom implementations. Included for convenience.","ref":"Md.Parser.Syntax.Void.html","title":"Md.Parser.Syntax.Void","type":"module"},{"doc":"Returns default values for outer tag, span tag and empty tags.","ref":"Md.Parser.Syntax.Void.html#settings/0","title":"Md.Parser.Syntax.Void.settings/0","type":"function"},{"doc":"Empty syntax","ref":"Md.Parser.Syntax.Void.html#syntax/0","title":"Md.Parser.Syntax.Void.syntax/0","type":"function"}]